<template>
  <q-page class="text-left">
    <body>
      <div class="q-pa-md">
        <strong>
          {{ this.question }}
        </strong>
        <p>{{ this.description }}</p>
      </div>
      <div class="text-center">
        <div class="row justify-center" id="container">
          <!--
      Using the pie chart component and providing the pieData
    -->
          <PieChart class="q-mr-xl" :pieData="pieData" />
          <q-table
            class="q-ml-xl"
            title="Details"
            :data="details"
            :columns="columns"
            :rows-per-page-options="[0]"
          />

          <!-- <ul class="block float-right">
            <li v-for="(data, index) in pieData" :key="index">
              {{ data.value }}
            </li>
          </ul> -->
        </div>
      </div>
      <div></div>
    </body>
  </q-page>
</template>

<script>
import PieChart from "../components/PieChart";
import { api } from "boot/axios";
export default {
  data: () => {
    return {
      /*
          Data for the pie chart, value is the percentage
        */
      columns: [
        { name: "option_no", align: "center", label: "#", field: "option_no" },

        { name: "option", align: "left", label: "Option", field: "option" },
        {
          name: "noVotes",
          align: "center",
          label: "No. Votes",
          field: "noVotes"
        },
        {
          name: "percentage",
          align: "right",
          label: "%",
          field: result => {
            return result.percentage.toPrecision(2) + "%";
          }
        }
      ],

      details: [],

      pieData: [
        // { color: "#0B6487", value: 82.5 },
        // { color: "#9D1F37", value: 7.5 },
        // { color: "#F6931C", value: 10 }
      ],
      question: "",
      description: ""
    };
  },
  components: {
    PieChart
  },
  methods: {
    async getDetails() {
      const url = window.location.pathname;
      const token = url.substring(url.lastIndexOf("/") + 1);
      var req = {
        polltkn: token,
        token: sessionStorage.token
      };
      // console.log(req);

      await api
        .post("/api/poll/getDetails", req)
        .then(res => {
          if (res.status == 200) {
            console.log("============");
            console.log(res.data);
            const results = res.data.details;
            this.description = res.data.desc;
            this.question = res.data.question;
            for (let i = 0; i < results.length; i++) {
              this.pieData.unshift({
                color: "#" + ((Math.random() * 0xffffff) << 0).toString(16),
                value: results[i].percentage
              });
              // console.log(i + ": " + results[i].option);
              this.details.unshift(results[i]);
            }
            // this.details.sort(function(a, b) {
            //   return a.option_no - b.option_no;
            // });
          }
        })
        .catch(error => {
          if (error.response.status == 404)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Poll not found"
            });

          if (error.response.status == 403)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "You don't have access to this poll"
            });

          if (error.response.status == 423)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Voting is no longer accepted in this poll"
            });

          if (error.response.status == 500)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Server error"
            });
        });
    }
  },
  created() {
    this.getDetails();
    console.log("pieData:");
    console.log(this.pieData);
    console.log("details:");
    console.log(this.details);
  }
};
</script>

<style lang="scss">
* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}
body {
  font-size: 1rem;
  font-family: Tahoma;
  color: #000;
}
#pollResult {
  position: relative;
  display: flex;
  justify-content: center;
  align-items: flex-start;
  min-height: 100vh;
  width: 100%;
  padding: 20px;
}
// #container {
//   @media screen and (max-width: 767px) {
//   }
// }
</style>
